<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Factories\PeriodoDeGeracaoRNFFactory;

class PeriodoDeGeracaoRNFService {
    protected $periodoDeGeracaoRNFFactory;
    
    public function __construct(PeriodoDeGeracaoRNFFactory $periodoDeGeracaoRNFFactory) {
        $this->periodoDeGeracaoRNFFactory = $periodoDeGeracaoRNFFactory;
    }
    
    public function findPeriodoGeracaoRNF($conditions) {
        $params = array(
            ':NRORG' => $conditions['NRORG']
        );
        
        return $this->periodoDeGeracaoRNFFactory->findPeriodoGeracaoRNF($params);
    }
    
    public function verificaParametrizacao($row) {
        $params = array(
            ':CDEMPRESA' => $row['CDEMPRESA']
        );
        
        return $this->periodoDeGeracaoRNFFactory->verificaParametrizacao($params);
    }
    
    public function insertPeriodoGeracaoRNF($row) {
        $params = array(
            ':CDEMPRESA' => $row['CDEMPRESA'],
            ':DTINICIAL' => $row['DTINICIAL'],
            ':DTFINAL'   => $row['DTFINAL']
        );
        
        return $this->periodoDeGeracaoRNFFactory->insertPeriodoGeracaoRNF($params);
    }
    
    public function updatePeriodoGeracaoRNF($row) {
        $params = array(
            ':CDEMPRESA' => $row['CDEMPRESA'],
            ':DTINICIAL' => $row['DTINICIAL'],
            ':DTFINAL'   => $row['DTFINAL']
        );
        
        return $this->periodoDeGeracaoRNFFactory->updatePeriodoGeracaoRNF($params);
    }
}