<?php
namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;

class Store {

    protected $entityManager;
    protected $storeData;
    
    const EM_DIA = "#00EE00";
	const NEGATIVO = "#EE0000";
	const ATRASADO = "#FFEE00";

    public function __construct(\Doctrine\ORM\EntityManager $entityManager){
        $this->entityManager = $entityManager;
        $this->storeData = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_STORE_DATA);
        $previousBranch = null;
        foreach($this->storeData as &$branchlet){
	        if ($branchlet['EXCEEDEDTIME'] == NULL){
	            $branchlet['SITUATION'] = 'NULL';
	        }
	        else if ($branchlet['EXCEEDEDTIME'] > 0.020833){
	            $branchlet['SITUATION'] = 'LATE';
	        }
	        else {
	            $branchlet['SITUATION'] = 'UPTODATE';
	        }

	        if ($branchlet['CDFILIAL'] == $previousBranch) $i++;  
	         else { 
	            $previousBranch = $branchlet['CDFILIAL'];
	            $i = 1;
	        }
	        $branchlet['ORDEMCX'] = 'CX '.$i;
	        if ($branchlet['DTVENDA']){
	        	$branchlet['DTVENDA'] = substr($branchlet['DTVENDA'], 8, 2).'/'.substr($branchlet['DTVENDA'], 5, 2).'/'.substr($branchlet['DTVENDA'], 0, 4).substr($branchlet['DTVENDA'], 10);
	        }
	        else {
	            $branchlet['DTVENDA'] = "Não houve exportações.";
	        }

	        $atraso = $branchlet['EXCEEDEDTIME'];
	        $branchlet['EXCEEDEDTIME'] = ceil($atraso*1440);	        
        }
    }


    public function getCaixasNegativos(){
    	$redBranchlets = array();
    	foreach($this->storeData as $branchlet){
    		if($branchlet['SITUATION'] == 'NULL'){
    			array_push($redBranchlets, $branchlet);
    		}
    	}
    	return $redBranchlets;
    }

    public function getCaixasAtrasados(){
    	$yellowBranchlets = array();
    	foreach($this->storeData as $branchlet){
    		if($branchlet['SITUATION'] == 'LATE'){
    			array_push($yellowBranchlets, $branchlet);
    		}
    	}
    	return $yellowBranchlets;
    }

    public function getCaixasEmDia(){
    	$greenBranchlets = array();
    	foreach($this->storeData as $branchlet){
    		if($branchlet['SITUATION'] == 'UPTODATE'){
    			array_push($greenBranchlets, $branchlet);
    		}
    	}
    	return $greenBranchlets;
    }


    public function getStoreDataGraph(){
        $red = 0;
        $yellow = 0;
        $green = 0;
        foreach($this->storeData as &$branchlet){

            if ($branchlet['EXCEEDEDTIME'] == NULL){
                $red++;
            }
            else if ($branchlet['EXCEEDEDTIME'] > 0.020833){
                $yellow++;
            }
            else {
                $green++;
            }
        }

        $red_ = array(
        			'SITUATION' => 'Caixas que não exportaram hoje',
        			'QUANTITY'=> $red,
        			'colorField' => "#EE0000"
        		);
        $yellow_ = array(
        			'SITUATION' => 'Caixas com mais de 30 minutos de atraso em exportações',
        			'QUANTITY' => $yellow,
        			'colorField' => "#FFEE00"
        		);
        $green_ = array(
        			'SITUATION' => 'Caixas com exportações em dia',
        			'QUANTITY' => $green,
        			'colorField' => "#00EE00"
        		);

        $retornoFinal = array();
        array_push($retornoFinal, $red_);
        array_push($retornoFinal, $yellow_);
        array_push($retornoFinal, $green_);
        /* Job's done. */
        return $retornoFinal;
    }
}